/* R[h͂rihr sR[h͂bqke */
/* $Id$ */

#include "stdafx.h"
#include "test_win_fmt.h"
#include "test_dmo_fmt.h"

void dmo_CoCreateInstance(REFGUID clsidCodec)
{
	HRESULT hr;
	IUnknown *pUnk;

	hr = CoCreateInstance(clsidCodec, NULL, CLSCTX_INPROC_SERVER, IID_IUnknown, (LPVOID*)&pUnk);
	BOOST_REQUIRE_EQUAL(hr, S_OK);
	BOOST_REQUIRE(pUnk != NULL);

	pUnk->Release();
}

BOOST_DATA_TEST_CASE(dmo_CoCreateInstance_encoder, data::make(vecCodecFcc), fcc)
{
	DMOEncoderCLSID clsid(fcc);
	dmo_CoCreateInstance(clsid);
}

BOOST_DATA_TEST_CASE(dmo_CoCreateInstance_decoder, data::make(vecCodecFcc), fcc)
{
	DMODecoderCLSID clsid(fcc);
	dmo_CoCreateInstance(clsid);
}
